'use strict';

/**
 *
 * @class Elastic
 * @author: yeliex
 * @create: 2017/8/24 下午2:53
 */
const Elasticsearch = require('elasticsearch');
const Model = require('./Model');

var _$models = new WeakMap();

var _$hosts = new WeakMap();

var _$client = new WeakMap();

class Elastic {

  constructor({ hosts, host } = {}) {
    _$models.set(this, {});

    _$hosts.set(this, hosts || [host]);

    _$client.set(this, new Elasticsearch.Client({
      hosts
    }));
  }

  define(name, attributes, options) {
    options.type = options.type || name;
    _$models.get(this)[name] = new Model(attributes, options, this.client);
  }

  get models() {
    return _$models.get(this);
  }

  get client() {
    return _$client.get(this);
  }
}

module.exports = Elastic;
//# sourceMappingURL=Elastic.js.map