'use strict';

/**
 * 错误系列构造函数
 * @class SeriesType
 * @author yeliex
 * @create 2017/8/23 下午2:18
 */
const assert = require('assert');

var _raw = new WeakMap();

class SeriesType {

  constructor(number, comment) {
    _raw.set(this, {});

    assert(Number.isInteger(Number(number)));
    assert(typeof comment === 'string');

    _raw.set(this, { number, comment });
  }

  get number() {
    return _raw.get(this).number;
  }

  set number(number) {
    _raw.get(this).number = number;
  }

  get comment() {
    return _raw.get(this).comment;
  }

  set comment(comment) {
    _raw.get(this).comment = comment;
  }

  toString() {
    return String(_raw.get(this).number);
  }

  equals(obj) {
    if (!obj instanceof SeriesType) {
      return false;
    }
    return obj.number === _raw.get(this).number && obj.comment === _raw.get(this).comment;
  }
}

module.exports = SeriesType;
//# sourceMappingURL=SeriesType.js.map