'use strict';

const MongoDB = require('node.mongo');

var _$models = new WeakMap();

var _$host = new WeakMap();

var _$port = new WeakMap();

var _$options = new WeakMap();

class Mongo {

  constructor({ host, port, options = {} }) {
    _$models.set(this, {});

    _$host.set(this, host);

    _$port.set(this, port);

    _$options.set(this, options);
  }

  define(name) {
    const url = `${_$host.get(this).replace(/^(mongodb:\/\/)?/, 'mongodb://')}${_$port.get(this) ? `:${_$port.get(this)}` : ''}/${name}`;
    _$models.get(this)[name] = MongoDB(url, _$options.get(this));
  }

  get models() {
    return _$models.get(this);
  }
}

module.exports = Mongo;
//# sourceMappingURL=Mongo.js.map